#include "ti83plus.inc"
#include "macrodie.inc"
.org $4000

; change this to your ID
#define DEVELOPER_ID    $01,$23,$45

EXT_APP = 1                         ; This definition is required of all apps

; This is the application header definition area required for all apps.

 .db $80, $0F                       ; Field: Program length
 .db 0, 0, 0, 0                     ; Length = 0 (N/A for unsigned apps)

#ifdef SIGN_APP
 .db $80, $13                       ; Field: Program type
 .db DEVELOPER_ID                   ; Type = Developer ID
#else
 .db $80, $12                       ; Field: Program type
 .db $01,$04                        ; Type = Shareware, TI-83+
#endif

 .db $80, $21                       ; Field: App ID
 .db 1                              ; Id = 1
 .db $80, $31                       ; Field: App Build
 .db 1                              ; Build = 1
 .db $80, $48                       ; Field: App Name
 .db "SCREENSA"                     ; Name -- must be 8 characters
 .db $80, $81                       ; Field: App Pages
 .db 1                              ; App Pages = 1
 .db $80, $90                       ; No default splash screen
 .db $03, $26, $09, $04, $04, $6f, $1b, $80             ; Field: Date stamp- 5/12/1999
 .db $02, $0d, $40, $a1, $6b, $99, $f6, $59, $bc, $67   ; Dummy encrypted TI date stamp signature
 .db $f5, $85, $9c, $09, $6c, $0f, $b4, $03, $9b, $c9
 .db $03, $32, $2c, $e0, $03, $20, $e3, $2c, $f4, $2d 
 .db $73, $b4, $27, $c4, $a0, $72, $54, $b9, $ea, $7c 
 .db $3b, $aa, $16, $f6, $77, $83, $7a, $ee, $1a, $d4 
 .db $42, $4c, $6b, $8b, $13, $1f, $bb, $93, $8b, $fc 
 .db $19, $1c, $3c, $ec, $4d, $e5, $75
 .db $80, $7f                       ; Field: Program Image length
 .db   0, 0, 0, 0                   ; Length = 0, N/A
 .db   0, 0, 0, 0                   ; Reserved
 .db   0, 0, 0, 0                   ; Reserved
 .db   0, 0, 0, 0                   ; Reserved
 .db   0, 0, 0                      ; Reserved
#ifndef SIGN_APP
 .db 0      ; add another pad byte if using only 2-byte keyfile
#endif
#define save_registers(m,a)     \ PUSH IY \ PUSH IX \ PUSH HL \ PUSH DE \ PUSH BC \ PUSH AF
#define restore_registers(m,a)  \ POP  AF \ POP  BC \ POP  DE \ POP  HL \ POP  IX \ POP  IY
StartApp:
;################################################
;########## MEMORY AREA #########################
;################################################
counter1             .equ $0000
counter2             .equ $0001
screensaver_flag     .equ $0002
ball_coord_x         .equ $0003
ball_coord_y         .equ $0004
current_position     .equ $0005
_Op1_register        .equ $0006;11 bytes 

;  Main app control begins here
    jp   error_ti_os;tios cannot execute this app
    jp   tell_macrodie_that_this_is_an_program;not driver and not library not macrodie
    jp   execute_background_task;this aplication executes in background only when to
    RET \ RET \ RET ;Mirageos prevent execution
    ;write data it will change to foregrand
STARTAPP: ;main control begins here
    xor  a
    invoke( create_default_pasta )
    LD   HL,aplication_name
    call copy_to_OP1;OP1 active
    xor  a
    invoke( find_memory_stack ) ;find the memory stack required
    cp   0 \ jr   z,memory_already_allocated
    
    LD   HL,2000;1KB of free mem to reserve
    xor  a
    invoke( allocate_ram_area );allocate some ram for the system
    CP   1 \ jp  z,ram_alloc_error
memory_already_allocated:    
    PUSH IX;save the memory pointer
code_execution_loop:
    xor   a;define macrodie page
    invoke( mouse );call macrodie mouse function
    POP   IX
verif_screen:    
    xor   a;macrodie page
    invoke(window_verif_coords);verificar as coordenadas
    LD   A,B
    ;buttoes
    ;1 - fechar
    ;2 - minimizar
    ;3 - retroceder
    ;4 - avancar
    ;5 - barra de tarefas
    ;0- nenhuma coord
    CP  1 \ jr   z,fechar_aplicacao 
    CP  2 \ jr   z,minimizar_aplicacao
    CP  3 \ jr   z,ignorar_botao
    CP  4 \ jr   z,ignorar_botao
    CP  5 \ jr   z,minimizar_aplicacao   
ignorar_botao:;default ignorar botao
    xor    a
    invoke( mouse );this is the second process message loop for the ininterrupted mouse
    jr    verif_screen
fechar_aplicacao:
    LD   A,(activ_task)
    LD   (close_task),A
    LD   HL,aplication_name
    call copy_to_OP1;OP1 active
    xor  a
    invoke( deallocate_ram_area ) ;find the memory stack required
    
fechar_aplica:
    
    
    XOR  A
    LD   (activ_task),A
    LD   (screen),A
    LD   (animar_flag),A
    RET;volto ao programa que esta a executar ou seja a pagina do macrodie e ao programa que me executou
minimizar_aplicacao:
    XOR  A
    LD   (close_task),A
    LD   (activ_task),A
    LD   (screen),A
    LD   (animar_flag),A
    jr   fechar_aplica    





;this label executes background things what you want in background
execute_background_task:
    EXX
    EX  AF,AF'
    save_registers(1,2);save the registers of the program's running
    ;// fisrt save the OP1 register as it is used by many programs
    call mov_op1_to_swap
    LD   HL,aplication_name;first find the memory area of my program
    call copy_to_OP1;OP1 active
    xor  a;macrodie page 
    invoke( find_memory_stack ) ;find it 
    CP   1 \ jr   z,error_could_not_process_background 
    call save_op1_in_swap
    ;now lets see if the user have pressed any key
    IN   A,(1)
    CP   $FF;well if it's FF is because the keyboard port is reseted and the user haven't pressed any key
    ;if so increment the counter for about 1 minute and then start screensaver mode
    jr    nz,dont_increment_counter;we must destroy the buffers and set the screensaver flag to zero
    LD    A,(IX+ screensaver_flag);if this flag is one then igore the rest of the process and process the screen
    CP    1 \ jr  z,process_screen_saver;well lets process the screen    
    LD    A,(IX+ counter1);get the value of counter
    CP    140;default value for 1s
    jr    z,increment_seconds
    INC   A
    LD    (IX+ counter1),A
    jr    error_could_not_process_background
increment_seconds:
    XOR   A
    LD    (IX+ counter1),A;reset counter
    LD    A,(IX+ counter2)
    CP    60;if 60 seconds then we have an minute is time for starting the screensaver
    jr    nz,increment_counter
    LD    A,48
    LD    (IX + ball_coord_x),A
    LD    A,32
    LD    (IX + ball_coord_y),A;coords seted
    LD    A,1
    LD    (IX + current_position),A;a cair
    LD    (IX + screensaver_flag),A
    call  put_ball_sprite1;coloca o sprite e esta tudo pronto para iniciar o loop
process_screen_saver:    
    XOR   A
    LD    (IX+ counter1),A
    LD    (IX+ counter2),A;counters erased
    call  proceed_with_screensaver
    jr    error_could_not_process_background
increment_counter:
    INC   A
    LD    (IX+ counter2),A
    jr    error_could_not_process_background
dont_increment_counter:
    LD    A,(IX+ screensaver_flag)
    CP    1 \ call z,put_ball_sprite1;as the ball is active we have to erase it
    XOR   A
    LD    (IX+ counter1),A
    LD    (IX+ counter2),A;counters erased
    LD    (IX+ screensaver_flag),A;erase the screensaver flag to for preventing execution
error_could_not_process_background:
    LD    A,$FF
    OUT   (1),A;reset key port
    call  restore_op1_from_memory
    restore_registers(1,2);restore the registers
    EXX
    EX  AF,AF'
    RET;para ja volta apenas para traz pois ainda nao tem nada defenido    

proceed_with_screensaver:
;this screen saver will move a ball around the screen
;for putting the ball in the screen we will use our routine for puting sprites on buffer and on screen
;it will move only one position at a time
;so lets go
;       
;       5
;     4   6
;    3     7
;     2   8
;       1 
    call put_ball_sprite;erase it
    LD   A,(IX + current_position)
    CP   1 \ jr   z,down
    CP   2 \ jr   z,down_left  
    CP   3 \ jr   z,left
    CP   4 \ jr   z,up_left
    CP   5 \ jr   z,up
    CP   6 \ jr   z,up_right
    CP   7 \ jr   z,right
    CP   8 \ jr   z,down_right
    call put_ball_sprite
    RET;ELSE RETURN WITH NO UPDATE
    
down:  
    LD   A,(IX + ball_coord_y)
    INC  A
    LD   (IX + ball_coord_y),A
    LD   A,1;check for down
    jr   verif_ball_coords
down_left:
    LD   A,(IX + ball_coord_y)
    INC  A
    LD   (IX + ball_coord_y),A
    LD   A,(IX + ball_coord_x)
    DEC  A
    LD   (IX + ball_coord_x),A
    LD   A,2;position 2 check
    jr   verif_ball_coords
left:
    LD   A,(IX + ball_coord_x)
    DEC  A
    LD   (IX + ball_coord_x),A
    LD   A,3
    jr   verif_ball_coords
up_left:
    LD   A,(IX + ball_coord_y)
    DEC  A
    LD   (IX + ball_coord_y),A
    LD   A,(IX + ball_coord_x)
    DEC  A
    LD   (IX + ball_coord_x),A
    LD   A,4;position 2 check
    jr   verif_ball_coords
up:    
    LD   A,(IX + ball_coord_y)
    DEC  A
    LD   (IX + ball_coord_y),A
    LD   A,5;check for down
    jr   verif_ball_coords    
up_right:
    LD   A,(IX + ball_coord_y)
    DEC  A
    LD   (IX + ball_coord_y),A
    LD   A,(IX + ball_coord_x)
    INC  A
    LD   (IX + ball_coord_x),A
    LD   A,6;position 2 check
    jr   verif_ball_coords   
right:
    LD   A,(IX + ball_coord_x)
    INC  A
    LD   (IX + ball_coord_x),A
    LD   A,7
    jr   verif_ball_coords      
down_right:
    LD   A,(IX + ball_coord_y)
    INC  A
    LD   (IX + ball_coord_y),A
    LD   A,(IX + ball_coord_x)
    INC  A
    LD   (IX + ball_coord_x),A
    LD   A,8;position 2 check
    jr   verif_ball_coords
                          
verif_ball_coords:
    PUSH AF
    call put_ball_sprite1;put it
    POP  AF
    CP   1 \ jr   z,verif_down
    CP   2 \ jr   z,verif_down_left
    CP   3 \ jr   z,verif_left
    CP   4 \ jr   z,verif_up_left
    CP   5 \ jr   z,verif_up
    CP   6 \ jp   z,verif_up_right
    CP   7 \ jp   z,verif_right
    CP   8 \ jp   z,verif_down_right
    RET;ELSE RETURN ITS AN ERROR
verif_down:
    LD   A,(IX + ball_coord_y)
    CP   56
    jr   nz,ignore_change_position
    LD   A,6
    LD   (IX + current_position),A
ignore_change_position:   
    RET;return to the queued process list
verif_down_left:
    LD   A,(IX + ball_coord_y)
    CP   56 \ jr  nz,verif_x1
    LD   A,(IX + ball_coord_x)
    CP   1  \ jr  nz,move_up_left
    LD   A,6
    LD   (IX + current_position),A
    RET
move_up_left:
    LD   A,4
    LD   (IX + current_position),A
    RET    
 
verif_x1:
    LD   A,(IX + ball_coord_x)
    CP   1 \ jr  nz,ignore_change_position
    LD   A,8
    LD   (IX + current_position),A
    RET
verif_left:
    LD   A,(IX + ball_coord_x)
    CP   1 \ jr  nz,ignore_change_position
    LD   A,7
    LD   (IX + current_position),A
ignore_change_position1:    
    RET
verif_up_left:
    LD   A,(IX + ball_coord_y)
    CP   1 \ jr  nz,verif_x2
    LD   A,(IX + ball_coord_x)
    CP   1 \ jr  nz,move_down_left
    LD   A,8;aki tava o erro k fazia com que a bola atravessa se o ecra
    LD   (IX + current_position),A
    RET
move_down_left:
    LD   A,2
    LD   (IX + current_position),A
    RET    
    
    
verif_x2:
    LD  A,(IX + ball_coord_x)
    CP  1 \ jr  nz,ignore_change_position1
    LD  A,6
    LD  (IX + current_position),A
    RET
verif_up:
    LD   A,(IX + ball_coord_y)
    CP   1 \ jr  nz,ignore_change_position1
    LD   A,1
    LD   (current_position),A
ignore_change_position2:   
    RET
verif_up_right:
    LD   A,(IX + ball_coord_y)
    CP   1 \ jr  nz,verif_x3
    LD   A,(IX + ball_coord_x)
    CP   88 \ jr  nz,move_down_right
    LD   A,2
    LD   (IX + current_position),A
    RET
move_down_right:
    LD   A,8
    LD   (IX + current_position),A
    RET
verif_x3:
    LD   A,(IX + ball_coord_x)
    CP   88 \ jr   nz,ignore_change_position2
    LD   A,4
    LD   (IX + current_position),A
    RET
verif_right:
    LD   A,(IX + ball_coord_x)
    CP   88 \ jr  nz,ignore_change_position2   
    LD   A,3
    LD   (IX + current_position),A
ignore_change_position3:    
    RET

verif_down_right:
    LD   A,(IX + ball_coord_y)
    CP   56 \ jr  nz,verif_x4
    LD   A,(IX + ball_coord_x)
    CP   88 \ jr  nz,move_up_right
    LD   A,4
    LD   (IX + current_position),A
    RET
move_up_right:
    LD   A,6
    LD   (IX + current_position),A
    RET
verif_x4:
    LD   A,(IX + ball_coord_x)
    CP   88 \ jr  nz,ignore_change_position3   
    LD   A,2
    LD   (IX + current_position),A
    RET

mov_op1_to_swap:
    LD   HL,_OP1
    LD   DE,_SaveSScreen
    LD   BC,11
    LDIR
    RET
save_op1_in_swap:
    LD   HL,_SaveSScreen
    LD   DE,_OP1
    LD   BC,11
    LDIR
    PUSH IX
    LD   DE,_Op1_register
    ADD  IX,DE
    xor  a
    invoke( save_Op1_register_to_memory )
    POP  IX
    ret
restore_op1_from_memory:
    PUSH IX
    LD   DE,_Op1_register
    ADD  IX,DE
    xor  a
    invoke( restore_Op1_register_from_memory )
    POP  IX
    ret
    
    
    
    

put_ball_sprite:
    LD   A,(IX + ball_coord_x)
    LD   L,(IX + ball_coord_y)
    LD   B,8
    LD   C,1
    PUSH IX
    LD   IX,ball_sprite
    call put_sprite
    POP  IX
    RET


put_ball_sprite1:
    call put_ball_sprite
    PUSH IX
    call fast_copy
    POP  IX;IX must be preserved
    RET


put_sprite:               
    ;DI because of the interrupts we can't use the macrodie routine
    ex  af,af'
    ld  a,c
    push    af
    ex  af,af'
    ld  e,l
    ld  h,$00
    ld  d,h
    add hl,de
    add hl,de
    add hl,hl
    add hl,hl
    ld  e,a
    and $07
    ld  c,a
    srl e
    srl e
    srl e
    add hl,de
    ld  de,_plotSScreen
    add hl,de
putSprite1:
    push    hl
putSprite2:
    ld  d,(ix)
    ld  e,$00
    ld  a,c
    or  a
    jr  z,putSpriteSkip1
putSprite3:
    srl d
    rr  e
    dec a
    jr  nz,putSprite3
putSpriteSkip1:
    ld  a,(hl)
    xor d
    ld  (hl),a
    inc hl
    ld  a,(hl)
    xor e
    ld  (hl),a
    inc ix
    ex  af,af'
    dec a
    push    af
    ex  af,af'
    pop af
    jr  nz,putSprite2
    pop hl
    pop af
    push    af
    ex  af,af'
    ld  de,$0C
    add hl,de
    djnz    putSprite1
    pop af
    ;EI
    ret    
   
fast_copy:
    ;di 
    IN  A,(20h);well this is because we don't know what is the actual speed
    PUSH AF
    XOR A
    OUT (20h),A;dispa a 6MHz
    ld  a,$80               
    out ($10),a             
    ld  hl,_plotSScreen-12-(-(12*64)+1)     
    ld  a,$20               
    ld  c,a             
    inc hl              
    dec hl        
fastCopyAgain:
    ld  b,64                
    inc c               
    ld  de,-(12*64)+1;10          
    out ($10),a
    add hl,de;11               
    ld  de,10;10               
fastCopyLoop:
    add hl,de;11               
    inc hl;6              
    inc hl;6            
    inc de;6            
    ld  a,(hl);7             
    out ($11),a
    dec  de 
    djnz    fastCopyLoop            
    ld  a,c;6             
    cp  $2B+1;11               
    jr  nz,fastCopyAgain
    POP AF
    OUT (20h),A;restaura a velocidade
    ;ei
    ret




putsprite_function:
    PUSH  HL
    PUSH  BC
    PUSH  IX
    POP   HL 
    LD    DE,_SaveSScreen
    LD    BC,16;16 bytes a copiar
    LDIR
    POP   BC
    POP   HL
    LD    IX,_SaveSScreen
    xor  a;macrodie page
    invoke( putsprite ); poe me o sprite no ecra
    RET
copy_to_OP1:
    LD   DE,_OP1
    LD   BC,8
    LDIR
    RET








copy_string_to_buffer:
;inputs HL-place of the string
;       BC-number of bytes to copy
     LD DE,_SaveSScreen
     LDIR
     LD HL,_SaveSScreen
     RET;come back with the string on buffer and HL pointing to buffer
     




;error zone
ram_alloc_error:
    LD   HL,error_ram_alloc
    LD   DE,_SaveSScreen;buffer mem can be used for what ever
    LD   BC,error_ti_os1 - error_ram_alloc
    LDIR;copy it to ram
    LD   DE,0
    LD   (_curCol),DE
    LD   HL,error_ram_alloc
    bcall _PutS
Enter_loop:
    LD   A,$FD
    OUT  (1),A
    IN   A,(1)
    CP   $FE;Enter key pressed
    jr   nz,Enter_loop
    jp    fechar_aplicacao;terminar aplicacao
       

tell_macrodie_that_this_is_an_program:
    LD    A,1;this is a program type aplication
    RET;return to whatever

error_ti_os:
    DI
    bcall _GRBUFCLR
    EI
    LD  HL,error_ti_os1
    LD  DE,buffer
    LD  BC,error_end - error_ti_os1
    LDIR
    LD  HL,buffer
    LD  DE,$0000
    LD  (_penCol),DE
    bcall _VPutS
    bcall _GetKey
    
    bjump _JForceCmdNoChar

 
    
    
error_ram_alloc: .db "Error allocating ram please unload some aplications in order to run this one!!! Please press Enter Key!!!",0   
error_ti_os1: .db "Error Ti operating system cann't execute this aplication",0
error_end:

aplication_name: .db "SCREEN00",0;the screen saver memory area
ball_sprite:
.db %01111110
.db %11111011
.db %11111101
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %01111110




.end
.end