;well this function reads a byte from keyboard and put it on the struct that you specifie
;inputs HL address of the struct
;struct type : number of chars , alpha status , end_status , max number of chars , free space 
;free space = this space will contain the string
;this routine should be putted inside a loop

get_keyboard:
;first init the keyboard
    PUSH HL \ POP DE;copy it to DE
    LD   B,(HL);get the number of chars 
    INC  HL
    LD   C,(HL)
    INC  HL
    INC  HL;HL points to data
    INC  HL
    
    call  m_keyboard  ; read a byte from keyboard this equals to getcsc only faster
    OR    A
    RET   Z;any key pressed if not return
    ;if yes check it and perform the correct operation
    CP    skEnter
    jr    nz,not_enter
    ;fill buffer with a leading zero
    LD    D,0
    LD    E,B
    INC   E
    ADD   HL,DE
    LD    (HL),0
    ;now tell the struct that user have pressed enter0
    RET;return   
not_enter:
    ;check alpha
    CP    skAlpha
    jr    nz,not_alpha
    ;disable  or enables alpha key
    LD    A,C
    XOR   1;now write it into C and table
    LD    C,A
    INC   DE
    LD    (DE),A
    RET;got back
not_alpha:
    CP    skDEL
    jr    nz,not_DEL
    ;erase last char on buffer
    ;B holds the number of chars on buffer
    ;first check B = zero
    LD    A,B
    OR    A \ jr  z,skip_del 
    PUSH  DE
    LD    D,0
    LD    E,B
    ADD   HL,DE;get the address of the byte
    LD    (HL),0;put there a zero
    ;now decrement the number of chars
    POP   HL
    DEC   B
    LD    (HL),B;update the number of chars
skip_del:    
    RET
not_DEL:
    cp   skClear
    jr   nz,not_clear
    ;IF CLEAR everithing must be cleared
    ;the number of chars is in B so lets clear
    ;first get the address of the last char
    ; and only then clear
    LD   A,B
    OR   A
    jr   z,skip_clear
    PUSH DE
    LD   D,0
    LD   E,B
    ADD  HL,DE;get the address
_clear_loop:
    LD   (HL),0
    DEC   HL
    DJNZ  _clear_loop
    ;now reset the number of chars
    POP   HL
    LD    (HL),0
skip_clear:
    RET;go back
not_clear:
;now we must check the number of chars
    LD    C,A;save char temporarly
    PUSH  DE
    INC   DE;alpha status
    INC   DE;end status
    INC   DE;number of chars max
    LD    A,(DE)
    CP    B
    jr    z,maximum_number_reached
    jr    c,maximum_number_reached
    POP   DE
    LD    A,C   
    SUB   skAdd;throw out all keys below +
    RET   C
    CP    skMath - skAdd + 1
    RET   NC
    PUSH  DE
    PUSH  HL
    INC   DE;alpha status
    LD    C,A;save chars temporarly
    LD    A,(DE)
    OR    A
    jr    z,alpha_not_locked
    LD    DE,CharTable
    jr    continue_write
alpha_not_locked:
    LD    DE,NormTable
continue_write
    LD    A,C
    LD    H,0
    LD    L,A
    ADD   HL,DE
    LD    A,(HL)
    ;get the char
    POP   HL
    
    LD    E,B
    LD    D,0
    ADD   HL,DE
    LD    (HL),A;write char into buffer
    POP   HL
    INC   B
    LD    (HL),B
    RET 
    
maximum_number_reached:
    POP   DE
    RET            

CharTable:
.DB  $27, "WRMH", $FF, $FF        ; + -   ^ undefined
.DB  "?", $5B, "VQLG", $FF, $FF    ; (-) 3 6 9 ) TAN VARS undefined
.DB  ":ZUPKFC", $FF             ; . 2 5 8 ( COS PRGM STAT
.DB  " YTOJEB", $FF, $FF         ; 0 1 4 7 , SIN APPS XT?n undefined
.DB  "XSNIDA"                  ; STO LN LOG x2 x-1 MATH

NormTable:
.DB  "+-*/^", $FF, $FF           ; + -   ^ CLEAR undefined
.DB  "_369)", $C1, "]", $FF       ; (-) 3 6 9 ) TAN VARS undefined
.DB  ".258({};"                ; . 2 5 8 ( COS PRGM STAT
.DB  "0147, <>|", $FF            ; 0 1 4 7 , SIN APPS XT?n undefined
.DB  $05, "!@#%&"               ; STO LN LOG x2 x-1 MATH

.end